'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = createElegantDecorator;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _statics = require('./statics');

var _shallowEqualProps = require('./shallow-equal-props');

var getDisplayName = function getDisplayName(Component) {
  return Component.displayName || Component.name || 'Component';
};

function createElegantDecorator(React, debug) {
  var Component = React.Component;

  var decorator = function decorator(_ref) {
    var statics = _ref.statics;

    var staticsMap = (0, _shallowEqualProps.createStaticsMap)(statics);

    return function (DecoratedComponent) {
      return (function (_Component) {
        function ElegantDecorator() {
          _classCallCheck(this, ElegantDecorator);

          _get(Object.getPrototypeOf(ElegantDecorator.prototype), 'constructor', this).apply(this, arguments);
        }

        _inherits(ElegantDecorator, _Component);

        _createClass(ElegantDecorator, [{
          key: 'shouldComponentUpdate',
          value: function shouldComponentUpdate(nextProps, nextState) {
            return !(0, _shallowEqualProps.shallowEqualProps)(this.props, nextProps, staticsMap);
          }
        }, {
          key: 'componentWillReceiveProps',
          value: function componentWillReceiveProps(newProps) {
            (0, _statics.updateStatics)(statics, this.decoratedProps, newProps);
          }
        }, {
          key: 'render',
          value: function render() {
            if (debug) console.log('render <' + ElegantDecorator.displayName + '>');

            this.decoratedProps = (0, _statics.wrapStatics)(statics, this.props);

            return React.createElement(DecoratedComponent, this.decoratedProps);
          }
        }], [{
          key: 'displayName',
          value: 'Elegant(' + getDisplayName(DecoratedComponent) + ')',
          enumerable: true
        }, {
          key: 'DecoratedComponent',
          value: DecoratedComponent,
          enumerable: true
        }]);

        return ElegantDecorator;
      })(Component);
    };
  };

  return function () {
    var optionsOrComponent = arguments[0] === undefined ? {} : arguments[0];
    return optionsOrComponent.prototype instanceof Component ? decorator({})(optionsOrComponent) : decorator(optionsOrComponent);
  }; // Component : options
}

module.exports = exports['default'];