'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.isDelegate = isDelegate;
exports.wrapStatics = wrapStatics;
exports.updateStatics = updateStatics;
function delegate(delegee) {
  var delegate = function delegate() {
    return delegate.delegee.apply(this, arguments);
  };
  delegate.delegee = delegee;
  delegate.isDelegate = true;
  return delegate;
}

function isDelegate(value) {
  return value && value.isDelegate;
}

// perform on render

function wrapStatics(statics, props) {
  var transformedProps = _extends({}, props);
  if (statics) {
    statics.forEach(function (key) {
      var delegee = props[key];
      if (typeof delegee === 'function') {
        transformedProps[key] = isDelegate(delegee) ? delegee : delegate(delegee);
      }
    });
  }
  return transformedProps;
}

// perform when recieving props

function updateStatics(statics, wrappedProps, newProps) {
  if (statics && newProps && wrappedProps) {
    statics.forEach(function (key) {
      var newMember = newProps[key];

      if (typeof newMember === 'function') {
        var currentMember = wrappedProps[key];
        if (isDelegate(currentMember)) {
          var delegee = isDelegate(newMember) ? newMember.delegee : newMember;
          currentMember.delegee = delegee;
        }
      }
    });
  }
}